"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FieldFile = void 0;
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const components_file_manager_1 = require("@react_db_client/components.file-manager");
const components_item_list_1 = require("@react_db_client/components.item-list");
/**
 * Form component file field
 *
 * Value should be either a single or array of file objects
 *
 */
const FieldFile = ({ uid, multiple, updateFormData, collectionId, documentId, fileType, value, fileServerUrl, asyncGetDocuments, 
// TODO: Add required check
// required,
PopupPanel, }) => {
    if (value && (typeof value !== 'object' || (value[0] && typeof value[0] !== 'object')))
        throw Error(`Value must be file type. Got ${value}`);
    const [fileList, setFileList] = (0, react_1.useState)(() => (Array.isArray(value) ? value : [value]));
    const [showFileSelectionPanel, setShowFileSelectionPanel] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        setFileList(Array.isArray(value) ? value : [value]);
    }, [value]);
    const handleSelected = (file, fileData) => {
        const newFileList = multiple ? [...fileList, ...fileData] : [fileData];
        setFileList(newFileList);
        setShowFileSelectionPanel(false);
        const newData = multiple ? [...fileList, ...fileData] : fileData;
        updateFormData(uid, newData);
    };
    const handleFileDelete = (fuid) => {
        const newFileList = fileList.filter((f) => f.uid !== fuid);
        setFileList(newFileList);
        const newData = multiple ? newFileList : null;
        updateFormData(uid, newData);
    };
    const filesData = (0, react_1.useMemo)(() => fileList &&
        fileList
            .filter((f) => f)
            .map((file) => ({
            uid: file.uid || file.name,
            label: file.name,
            type: fileType === 'image' ? 'image' : 'button',
            src: `${fileServerUrl}/${file.filePath}`,
        })), [fileList, fileType]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(PopupPanel, { isOpen: showFileSelectionPanel, handleClose: () => setShowFileSelectionPanel(false), title: "File Selector" },
            react_1.default.createElement(components_file_manager_1.FileManager, { handleSelect: handleSelected, collectionId: collectionId, documentId: documentId, fileType: fileType, allowMultiple: multiple, asyncGetDocuments: asyncGetDocuments, fileServerUrl: fileServerUrl })),
        react_1.default.createElement("div", { className: "FieldFile" },
            react_1.default.createElement("div", null,
                react_1.default.createElement("button", { type: "button", className: "button-one addFileBtn", onClick: () => setShowFileSelectionPanel(true) }, "Add File")),
            react_1.default.createElement("div", { style: { display: 'flex' } },
                "Files:",
                react_1.default.createElement(components_item_list_1.ItemList, { viewType: fileType === 'image' ? 'grid' : 'list', items: filesData, overlayButtons: [
                        {
                            uid: 'remove',
                            func: (fuid) => handleFileDelete(fuid),
                            label: 'Remove',
                            icon: '🗑️',
                        },
                    ] })))));
};
exports.FieldFile = FieldFile;
const fileValueShape = {
    filePath: prop_types_1.default.string.isRequired,
    name: prop_types_1.default.string.isRequired,
};
exports.FieldFile.propTypes = {
    uid: prop_types_1.default.string.isRequired,
    value: prop_types_1.default.oneOfType([
        prop_types_1.default.shape(fileValueShape),
        prop_types_1.default.arrayOf(prop_types_1.default.shape(fileValueShape)),
    ]),
    updateFormData: prop_types_1.default.func.isRequired,
    collectionId: prop_types_1.default.string.isRequired,
    documentId: prop_types_1.default.string.isRequired,
    fileType: prop_types_1.default.oneOf(['image', 'document', 'data', '*']),
    multiple: prop_types_1.default.bool,
    fileServerUrl: prop_types_1.default.string.isRequired,
    asyncGetDocuments: prop_types_1.default.func.isRequired,
    PopupPanel: prop_types_1.default.elementType.isRequired,
};
exports.FieldFile.defaultProps = {
    value: [],
    multiple: false,
    fileType: '*',
    PopupPanel: ({ children, isOpen }) => (isOpen ? children : ''),
};
//# sourceMappingURL=field-file.js.map